#include <bits/stdc++.h>
using namespace std;
long long T, t, ma, n, i, m[1400007], a, b, c, d, C[1400007], xs, ys;
long long ansxy;
pair<long long, long long> mx[1400007], my[1400007];
set<int>M[1400007];
map<long long, long long> iscon[1400007];

long long f(long long x, long long y){
    ansxy=-1;
    for(auto k : M[x+d]){
        if(M[y+d].count(k)==1){
            ansxy=max(iscon[x+d][k]+iscon[y+d][k]+C[i], ansxy);
        }
    }
    return ansxy;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    d=0;
    cin>>T;
    for(t=1;t<=T; t++){
        ma=0;
        d+=2*n;
        for(i=1;i<=2*n; i++){
            m[i]=0;
        }
        cin>>n;
        for(i=1;i<=n;i++){
            cin>>a>>b>>c;
            C[i]=c;
            iscon[a+d][b]=c;
            M[a+d].insert(b);
            iscon[b+d][a]=c;
            M[b+d].insert(a);
            m[a]+=c; m[b]+=c;
            ma=max({ma, m[a], m[b], f(a, b)});
        }
        cout<<ma<<endl;
    }
}
